﻿var LINK_BLOCK_ID = 'links';
var LINK_FILE_URI = '/link.xml';

/* ------------------------------------------------------------------------------ */

var Link = Class.create();
Link.prototype = {
    uri: '',
    text: '',
    initialize: function(uri, text) {
        this.uri = uri;
        this.text = text;
    },
    toNode: function() {
        var linkNode = document.createElement('li');
        var a = document.createElement('a');
        a.setAttribute('target', '_blank');
        a.setAttribute('href', this.uri);
        a.appendChild(document.createTextNode(this.text));
        linkNode.appendChild(a);
        return linkNode;
    }
}

/* ------------------------------------------------------------------------------ */

// onload
addEvent(window, 'load', showLink);

/* ------------------------------------------------------------------------------ */

function showLink() {
    createLoading();
    showLoading();
    new Ajax.Request(
        LINK_FILE_URI,
        {
            method: 'get',
            onSuccess: linkSuccess,
            onComplete: linkComplete,
            onFailure: linkFailure
        }
    );
}

/* ------------------------------------------------------------------------------ */

function linkSuccess(file) {
    hideLoading();
    addLinks(file.responseXML.documentElement);
}
function linkComplete() { }
function linkFailure() { }

function addLinks(root) {
    var linkBlock = $(LINK_BLOCK_ID);
    var linkGroups = $A(root.getElementsByTagName('linkgroup'));
    linkGroups.each(function(linkGroup) {
        var groupname = linkGroup.getAttribute('name');
        var groupnameNode = document.createElement('h2');
        groupnameNode.appendChild(document.createTextNode(groupname));
        linkBlock.appendChild(groupnameNode);
        var linkGroupNode = document.createElement('ul');
        linkBlock.appendChild(linkGroupNode);
        $A(linkGroup.getElementsByTagName('link')).each(function(link) {
            var uriNode = link.getElementsByTagName('uri')[0];
            var textNode = link.getElementsByTagName('text')[0];
            var linkObj = new Link(
                uriNode.firstChild.nodeValue,
                textNode.firstChild.nodeValue);
            linkGroupNode.appendChild(linkObj.toNode());
        });
    });
    removeLoading();
}
